\documentclass{article}
\usepackage[T1]{fontenc}
\usepackage[latin1]{inputenc}
\IfFileExists{url.sty}{\usepackage{url}}
                      {\newcommand{\url}{\texttt}}
\usepackage{ifthen}
% =======================================================================
% new commands specfic to this file
% =======================================================================
\newcommand{\Description}{\subsubsection{Description}}
\newcommand{\FunctionDesc}[2]{\subsection{#1 - #2}}
\newcommand{\Param}[1]{{\bf #1}}
\newcommand{\ParameterValue}[3]{\Param{#1} & {\it #2} & #3 \\ \hline}
\newcommand{\ReturnValue}[1]{\subsubsection{Return Value}
{\it #1} - }
% =======================================================================
% new environments specfic to this file
% =======================================================================
\newcommand{\Example}[2]%
{\begin{itemize}
{\item Example #1}
\end{itemize}
\begin{quotation}#2
\end{quotation}}%Example
\newenvironment{Parameters}%
{\subsubsection{Parameters}
\begin{tabular}{|l|l|l|}\hline
\multicolumn{1}{|c|}{Parameter} &
\multicolumn{1}{|c|}{Type} &
\multicolumn{1}{|c|}{Description} \\ \hline
}%
{\end{tabular}}
\newenvironment{Synopsis}%
{\subsubsection{Synopsis}}% Synopsis - begin
{}% Synopsis - end
% =======================================================================
%  Commands that depend on our environments
% =======================================================================
\newcommand{\Examples}[2]{%
\Example{TCL}{#1}
\Example{Python}{#2}}
% =======================================================================
%  Begin Document
% =======================================================================
\begin{document}
\title{Diskcache Programming Guide}
%
\maketitle
\tableofcontents{}
%
\section{Interfacing to the Diskcache Library}
% -----------------------------------------------------------------------
% deleteDirCache
% -----------------------------------------------------------------------
\FunctionDesc{deleteDirCache}{Delete global frame data hash}
\begin{Synopsis}
\Examples{%
deleteDirCache
}{%
diskscan.deleteDirCache( )
}
\end{Synopsis}
\Description%
{\bf ATTN:} This function destroys existing hash in memory.
Caller must assure there are no running threads that might access global
frame data hash at the time ``deleteDirCache'' is called.
% -----------------------------------------------------------------------
% excludeDirList
% -----------------------------------------------------------------------
\FunctionDesc{excludedDirList}{Update list of excluded directories}
\begin{Synopsis}
\Examples{%
set dir\_list [ excludedDirList \Param{dirs\_to\_exclude} ]
}{%
dir\_list = diskscan.excludedDirList( \Param{dirs\_to\_exclude} )
}
\end{Synopsis}
\Description%
Update list of excluded directories (as they appear in the resource file): check if existing data hash relies on such directories already, remove those directories recursively from global hash.
\begin{Parameters}
\ParameterValue{dirs\_to\_exclude}{string}%
{A list of directories to exclude (as they appear in API resource file variable).}
\end{Parameters}
\ReturnValue{string}
Sorted Tcl list of all removed subdirectories,
followed by error messages if any:
\{Directories excluded by pattern 'dir\_list': dir1 dir2 ...\}
\{error1 error2 ...\}
%
% getDirEnt
%
\FunctionDesc{getDirEnt}{Invoke ``slow'' scan}
\begin{Synopsis}
\Examples{%
set dirents [ getDirEnt \Param{dirpath} ]
}{%
dirents = diskscan.getDirEnt( \Param{dirpath} )
}
\end{Synopsis}
\Description
Invoke ``slow'' scan (recursive collection of subdirectories and frame data
files) on directory listed in MOUNT\_PT list (rsc file variable).

This function gets recursive content of the passed to it directory.
It should be called only for directories that appear in the MOUNT\_PT list.
The same function is used to introduce new MOUNT\_PT directory or to rescan
already existing directory in the global hash for new data.
\begin{Parameters}
\ParameterValue{dirpath}{string}%
{A full path to the directory.}
\end{Parameters}
\ReturnValue{string}%
{A list of all identified and scanned subdirectories that have frame data.}
% -----------------------------------------------------------------------
% readDirCache
% -----------------------------------------------------------------------
\FunctionDesc{readDirCache}%
{Read content of global frame data hash from binary file.}
\begin{Synopsis}
\Examples{%
readDirCache \Param{filename}
}{%
diskscan.readDirCache( \Param{filename} )
}
\end{Synopsis}
\Description
Scripting layer can specify different files for read and write operations.
This function forces all read and write operations to be sequencial.

{\bf ATTN:} This function destroys existing hash before reading a new one
from the given file.
Caller must assure there are no running threads that might access global
frame data hash at the time {\it readDirCache} is called.

\begin{Parameters}
\ParameterValue{filename}{string}%
{Name of the file to read frame hash from.
Default is an empty string (C++ will use default file name).}
\end{Parameters}
% -----------------------------------------------------------------------
% updateMountPtList
% -----------------------------------------------------------------------
\FunctionDesc{updateMountPtList}{Update list of mount point directories}
\begin{Synopsis}
\Examples{%
set dir\_list [ updateMountPtList \Param{known\_mount\_pt\_dirs} \Param{enable\_global\_check} ]
}{%
dir\_list = diskscan.updateMountPtList( \Param{known\_mount\_pt\_dirs}, \Param{enable\_global\_check} )
}
\end{Synopsis}
\Description
Update list of mount point directories (as they appear in the resource file):
initialize list if called at API startup time;
otherwise, check if any MOUNT\_PT directory has been pruned,
and remove that directory from global hash.

\begin{Parameters}
\ParameterValue{dir\_list}{string}%
{A list of directories as they appear in MOUNT\_PT list
(API resource file variable).}
\ParameterValue{enable\_global\_check}{bool}%
{A flag to indicate if API should check for data conflicts across all MOUNT\_PT
entries (diskcacheAPI@LDAS reports data conflicts only under the same
MOUNT\_PT).
This flag should be set to TRUE only when called by outside of LDAS utility,
such as /ldas/bin/cacheCheck. Default is FALSE.}
\end{Parameters}
\ReturnValue{string}%
{Sorted Tcl list of all removed subdirectories, followed by error
messages if any. }
% -----------------------------------------------------------------------
% getDirCache
% -----------------------------------------------------------------------
\FunctionDesc{getDirCache}{Get ASCII representation of the current frame hash.}
\begin{Synopsis}
\Examples{%
set dircache [ getDirCache ]
}{%
dircache = diskscan.getDirCache( )
}
\end{Synopsis}
\Description
Get ASCII representation of the current frame hash in Tcl-layer requested
format.

\begin{Parameters}
\ParameterValue{ifo}{string}{An ifo to look up. Default is {\it all}.}
\ParameterValue{type}{string}{A type to look up. Default is {\it all}.}
\end{Parameters}
\ReturnValue{string}%
{A list of all identified subdirectories that contain frame data with
a Tcl-layer requested metadata, such as:
DirectoryName,IFO,Type,NumberOfFramesPerFile(always 1),dT(file),
MTIME NUMBER\_OF\_FRAMES\_IN\_DIR \{StartTime StopTime ...\} }
% -----------------------------------------------------------------------
% writeDirCache
% -----------------------------------------------------------------------
\FunctionDesc{writeDirCache}%
{Write content of global frame data hash to binary file.}
\begin{Synopsis}
\Examples{%
writeDirCache \Param{filename}
}{%
diskscan.writeDirCache( \Param{filename} )
}
\end{Synopsis}
\Description
Write content of global frame data hash to binary file.

Scripting layer can specify different files for read and write operations.
This function forces all read and write operations to be sequencial.

\begin{Parameters}
\ParameterValue{filename}{string}%
{Name of the file to write frame hash to.
Default is an empty string (C++ will use default file name).}
\end{Parameters}
% -----------------------------------------------------------------------
% getHashNumbers
% -----------------------------------------------------------------------
\FunctionDesc{getHashNumbers}%
{Get TCL formatted lists for each mount point}
\begin{Synopsis}
\Examples{%
set string [ getHashNumbers ]
}{%
string = diskscan.getHashNumbers( )
}
\end{Synopsis}
\Description
Get TCL formatted lists for each mount point with name or mount point,
number of directories and number of files for data matching the specified
ifo and type.
Return lists are of the form: \{mountpoint\_name number\_of\_dirs number\_of\_files \}

\begin{Parameters}
\ParameterValue{ifo}{string}%
{An ifo to look up. Default is {\it all}.}
\ParameterValue{type}{string}%
{A type to look up. Default is {\it all}.}
\end{Parameters}
\ReturnValue{string}%
{A list for each mount point with name, number of directories and number of
files under that mount point:
\{ mountpoint\_name number\_of\_dirs number\_of files \}}
% -----------------------------------------------------------------------
% getDirEnt_t
% -----------------------------------------------------------------------
\FunctionDesc{getDirEnt\_t}{Threaded version of getDirEnt}
\begin{Synopsis}
\Examples{%
set tid [ getDirEnt \Param{dirpath} ]
}{%
{\bf Not Available}
}
\end{Synopsis}
\Description
This is the threaded version of getDirEnt.
\begin{Parameters}
\ParameterValue{dirpath}{string}%
{A full path to the directory.}
\end{Parameters}
\ReturnValue{string}%
{Thread id of thread running the getDirEnt function}
% -----------------------------------------------------------------------
% getDirEnt\_r
% -----------------------------------------------------------------------
\FunctionDesc{getDirEnt\_r}{Thread reaper for getDirEnt\_t}
\begin{Synopsis}
\Examples{%
set dirents [ getDirEnt\_r \Param{\$tid} ]
}{%
{\bf Not Available}
}
\end{Synopsis}
\Description
This function gathers the results from a getDirEnt\_t call.
\begin{Parameters}
\ParameterValue{tid}{string}%
{Thread id as returned from getDirEnt\_r}
\end{Parameters}
\ReturnValue{string}%
{A list of all identified and scanned subdirectories that have frame data.}
% -----------------------------------------------------------------------
% readDirCache\_t
% -----------------------------------------------------------------------
\FunctionDesc{readDirCache\_t}{Threaded version of readDirCahce}
\begin{Synopsis}
\Examples{%
set tid [ readDirCache\_t \Param{filename} ]
}{%
{\bf Not Available}
}
\end{Synopsis}
\Description
This function invokes a thread to perform the same task as readDirCache
\begin{Parameters}
\ParameterValue{filename}{string}%
{Name of the file to read frame hash from.
Default is an empty string (C++ will use default file name).}
\end{Parameters}
\ReturnValue{string}%
{The thread id for the thread associated with the call.}
% -----------------------------------------------------------------------
% readDirCache\_r
% -----------------------------------------------------------------------
\FunctionDesc{readDirCache\_r}{Thread reaper for readDirCache\_t}
\begin{Synopsis}
\Examples{%
readDirCache\_r \Param{\$tid}
}{%
{\bf Not Available}
}
\end{Synopsis}
\Description
This reaps the thread started by readDirCache\_t.
\begin{Parameters}
\ParameterValue{tid}{string}%
{}
\end{Parameters}
% -----------------------------------------------------------------------
% setAlert
% -----------------------------------------------------------------------
\FunctionDesc{setAlert}{Establish trace variable for threaded call}
\begin{Synopsis}
\Examples{%
setAlert \Param{\$tid} \Param{tid\_state}
}{%
{\bf Not Available}
}
\end{Synopsis}
\Description
This function allows the caller to monitor the state of a thread without
polling.
\begin{Parameters}
\ParameterValue{tid}{string}%
{Thread to monitor.}
\ParameterValue{tid\_state}{string}%
{Name of TCL variable in which to store thread state}
\end{Parameters}
\ReturnValue{string}{}
\end{document}
